#include "stdafx.h"
#include "ng_main.h"
#include <winbase.h>

void __NG__ReportError(JSContext *cx, const char *message, JSErrorReport *report){
	jsval v;
	jsval v2;
	JSObject *o;
	JSObject *o2;
	char str[1024];

	if(JS_IsExceptionPending(cx)
			&& JS_GetPendingException(cx,&v)
			&& JS_GetProperty(cx,JS_GetGlobalObject(cx),"__NG__ExitSuccessfully",&v2)
	){
		JS_ValueToObject(cx,v,&o);
		JS_ValueToObject(cx,v2,&o2);
		if(o==o2){
			return;
		}else{
			sprintf_s((char *)str, (size_t)1024, "Exception: %s\nline %u @ %s\n",message,(unsigned int) report->lineno,
				report->filename ? report->filename : "<not a file>"
			);
		}
	}else{
		sprintf_s((char *)str,(size_t)1024, "%s\nline %u @ %s\n",message,(unsigned int) report->lineno,
			report->filename ? report->filename : "<not a file>"
		);
	}
	if(GetFileType(GetStdHandle(-12))){
		WriteFile(GetStdHandle(-12),str,strlen(str)*sizeof(char),NULL,NULL);
	}else{
		MessageBoxA(0,str,"Script Errror",MB_ICONERROR);
	}
}

int _tmain(int argc, _TCHAR* argv[]){
	int res=1;
	wchar_t filepath[MAX_PATH];
	DWORD plen;
	
	JSRuntime *rt;
	JSContext *cx;
	JSObject  *global;
	jsval rval;
	
	ULONG HeapInformation=2;//HEAP_LFH
	g_heap=HeapCreate(HEAP_CREATE_ENABLE_EXECUTE,0,0);
	HeapSetInformation(g_heap,HeapCompatibilityInformation,&HeapInformation,sizeof(HeapInformation));

	SetDllDirectory(L"");
	GetModuleFileNameW(NULL,filepath,MAX_PATH);
	plen=wcslen(filepath);
	wcscpy(filepath+plen-3, L"js\0");

	if((rt = JS_NewRuntime(64L * 1024L * 1024L))!= NULL){
		if ((cx = __NG__CreateContextMain(rt)) != NULL){
			JS_SetContextThread(cx);
			JS_BeginRequest(cx);
			JS_SetErrorReporter(cx, __NG__ReportError);
			if(global = __NG__CreateGlobal(cx,true)){
				__NG__EvalFileMain(cx,filepath,global,&rval) ? 0 : 1 ;
				JS_ValueToECMAInt32(cx,rval,(int32*)(&res));
			}
			JS_DestroyContext(cx);
			JS_EndRequest(cx);
		}
		JS_DestroyRuntime(rt);
	}
	JS_ShutDown();
	return res;
}

