#include "stdafx.h"
#include <jsapi.h>
#include <windows.h>
JSObject *__NG__CreateGlobal(JSContext *cx, bool define_funcs);
JSContext *__NG__CreateContextMain(JSRuntime *rt);


HANDLE g_heap;

#define HEAP_ALLOC(size) HeapAlloc(g_heap, HEAP_ZERO_MEMORY,size)
#define HEAP_FREE(addr) HeapFree(g_heap,0,(void *)addr)


void ReportStructuredException(JSContext *cx,PEXCEPTION_POINTERS e){
	jsval errval;
	switch(e->ExceptionRecord->ExceptionCode){
		case(EXCEPTION_ACCESS_VIOLATION):{
			if(e->ExceptionRecord->NumberParameters>1){
				if((DWORD)e->ExceptionRecord->ExceptionInformation[0]==1){
					JS_ReportError(cx,"Access Violation on 0x%X (writing 0x%X)",(DWORD)e->ExceptionRecord->ExceptionAddress,(DWORD)e->ExceptionRecord->ExceptionInformation[1]);
				}else{
					JS_ReportError(cx,"Access Violation on 0x%X (reading 0x%X)",(DWORD)e->ExceptionRecord->ExceptionAddress,(DWORD)e->ExceptionRecord->ExceptionInformation[1]);
				}
				JS_GetPendingException(cx,&errval);
				JS_DefineProperty(cx,JSVAL_TO_OBJECT(errval),"flag",INT_TO_JSVAL((DWORD)e->ExceptionRecord->ExceptionInformation[0]),NULL,NULL,0);
				JS_DefineProperty(cx,JSVAL_TO_OBJECT(errval),"address",INT_TO_JSVAL((DWORD)e->ExceptionRecord->ExceptionInformation[1]),NULL,NULL,0);
			}else{
					JS_ReportError(cx,"Access Violation on 0x%X",(DWORD)e->ExceptionRecord->ExceptionAddress);
				JS_GetPendingException(cx,&errval);
			}
			JS_DefineProperty(cx,JSVAL_TO_OBJECT(errval),"code",INT_TO_JSVAL(e->ExceptionRecord->ExceptionCode),NULL,NULL,0);
			break;
		 }default:{
			JS_ReportError(cx,"StructuredException=0x%X on 0x%X",e->ExceptionRecord->ExceptionCode,(DWORD)e->ExceptionRecord->ExceptionAddress);
			JS_GetPendingException(cx,&errval);
			JS_DefineProperty(cx,JSVAL_TO_OBJECT(errval),"code",INT_TO_JSVAL(e->ExceptionRecord->ExceptionCode),NULL,NULL,0);
			break;
		 }
	}
}
#define SEH_BEGIN PEXCEPTION_POINTERS e;__try
#define SEH_END __except( e = GetExceptionInformation(), EXCEPTION_EXECUTE_HANDLER ) {ReportStructuredException(cx,e);return JS_FALSE;}



JSBool __NG__WideCharToStr(char **dest,size_t *size,wchar_t *src){
	size_t s;
	char *buf;
	s=WideCharToMultiByte(CP_ACP,0,src,-1,0,0,NULL,NULL);
	buf=(char *)HEAP_ALLOC(s*sizeof(char *));
	WideCharToMultiByte(CP_ACP,0,src,-1,buf,s,NULL,NULL);
	*dest=buf;
	if(size!=NULL){
		*size=s;
	}
	return JS_TRUE;
}

JSBool __NG__StrToWideChar(wchar_t **dest, size_t *size, char *src){
	size_t wsrcsize;
	wchar_t *wsrc2;
	if((wsrcsize=MultiByteToWideChar(CP_ACP,MB_USEGLYPHCHARS|MB_ERR_INVALID_CHARS,src,-1,NULL,0))==0){
		wsrcsize=MultiByteToWideChar(CP_UTF8,0,src,-1,NULL,0);
		wsrc2=(wchar_t*)HEAP_ALLOC(wsrcsize*sizeof(wchar_t));
		MultiByteToWideChar(CP_UTF8,0,src,-1,wsrc2,wsrcsize);
	}else{
		wsrc2=(wchar_t*)HEAP_ALLOC(wsrcsize*sizeof(wchar_t));
		MultiByteToWideChar(CP_ACP,0,src,-1,wsrc2,wsrcsize);
	}
	*dest=wsrc2;
	if(size!=NULL){
		*size=wsrcsize;
	}
	return JS_TRUE;
}



JSBool __NG__GetModuleHandle(JSContext *cx, int argc, jsval *vp){
    wchar_t *name;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx, argc, JS_ARGV(cx,vp), "W", &name)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		return JS_NewNumberValue(cx, (double)(unsigned int)GetModuleHandleW(name), vp);
	}SEH_END;
}

JSBool __NG__LoadLibrary(JSContext *cx, int argc, jsval *vp){
    wchar_t *name;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx, argc, JS_ARGV(cx,vp), "W", &name)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		return JS_NewNumberValue(cx, (double)(unsigned int)LoadLibraryW(name), vp);
	}SEH_END;
}

JSBool __NG__GetProcAddress(JSContext *cx, int argc, jsval *vp){
	HMODULE h;
	char *name;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"us",&h,&name)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		return JS_NewNumberValue(cx, (double)(unsigned int)GetProcAddress(h,name), vp);
	}SEH_END;
}

JSBool __NG__FreeLibrary(JSContext *cx, int argc, jsval *vp){
	HMODULE h;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&h)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		FreeLibrary(h);
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
    return JS_TRUE;
}


JSBool __NG__Alloc(JSContext *cx, int argc, jsval *vp){
	unsigned int size;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&size)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		return JS_NewNumberValue(cx, (double)(unsigned int)HEAP_ALLOC(size), vp);
	}SEH_END;
}

JSBool __NG__Free(JSContext *cx, int argc, jsval *vp){
	void *addr;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&addr)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		HEAP_FREE(addr);
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
    return JS_TRUE;	
}

JSBool __NG__MoveMemory(JSContext *cx, int argc, jsval *vp){
	void *dest;
	void *src;
	size_t s;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"uuu",&dest,&src,&s)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		memmove(dest,src,s);
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
    return JS_TRUE;	
}









JSBool __NG__GetUInt64(JSContext *cx, int argc, jsval *vp){
	unsigned __int64  *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		JS_NewNumberValue(cx,(double)(*p), vp);
	}SEH_END;

	return JS_TRUE;
}

JSBool __NG__SetUInt64(JSContext *cx, int argc, jsval *vp){
	unsigned __int64  *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(unsigned __int64)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__GetInt64(JSContext *cx, int argc, jsval *vp){
	LONGLONG  *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		JS_NewNumberValue(cx,(double)(*p), vp);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetInt64(JSContext *cx, int argc, jsval *vp){
	LONGLONG  *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(LONGLONG)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__GetInt(JSContext *cx, int argc, jsval *vp){
	int *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		if(INT_FITS_IN_JSVAL(*p)){
			JS_SET_RVAL(cx,vp,INT_TO_JSVAL(*p));
		}else{
			JS_NewNumberValue(cx,(double)(*p), vp);
		}
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetInt(JSContext *cx, int argc, jsval *vp){
	int *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(int)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}


JSBool __NG__GetUInt(JSContext *cx, int argc, jsval *vp){
	DWORD *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		if(*p<JSVAL_INT_MAX){
			JS_SET_RVAL(cx,vp,INT_TO_JSVAL(*p));
		}else{
			JS_NewNumberValue(cx,(double)(*p), vp);
		}
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetUInt(JSContext *cx, int argc, jsval *vp){
	DWORD *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(DWORD)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__GetShort(JSContext *cx, int argc, jsval *vp){
	short *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		JS_SET_RVAL(cx,vp,INT_TO_JSVAL((int)(*p)));
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetShort(JSContext *cx, int argc, jsval *vp){
	short *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(short)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__GetWord(JSContext *cx, int argc, jsval *vp){
	unsigned short *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		JS_SET_RVAL(cx,vp,INT_TO_JSVAL((int)(*p)));
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetWord(JSContext *cx, int argc, jsval *vp){
	unsigned short *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(unsigned short)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__GetChar(JSContext *cx, int argc, jsval *vp){
	char *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		JS_SET_RVAL(cx,vp,INT_TO_JSVAL((int)(*p)));
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetChar(JSContext *cx, int argc, jsval *vp){
	char *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(char)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__GetByte(JSContext *cx, int argc, jsval *vp){
	unsigned char *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		JS_SET_RVAL(cx,vp,INT_TO_JSVAL((int)(*p)));
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetByte(JSContext *cx, int argc, jsval *vp){
	unsigned char *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(unsigned char)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__GetFloat(JSContext *cx, int argc, jsval *vp){
	float *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
//		JS_SET_RVAL(cx,vp,DOUBLE_TO_JSVAL(&value));
		JS_NewNumberValue(cx, (double)(*p), vp);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetFloat(JSContext *cx, int argc, jsval *vp){
	float *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=(float)value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__GetDouble(JSContext *cx, int argc, jsval *vp){
	double *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
//		JS_SET_RVAL(cx,vp,DOUBLE_TO_JSVAL(p));
		JS_NewNumberValue(cx, *p, vp);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetDouble(JSContext *cx, int argc, jsval *vp){
	double *p;
	double value;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ud",&p,&value)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		*p=value;
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}





JSBool __NG__GetStr(JSContext *cx, int argc, jsval *vp){
	char *p;
	wchar_t *p2;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		__NG__StrToWideChar(&p2,NULL,p);
		JS_SET_RVAL(cx,vp,STRING_TO_JSVAL(JS_NewUCStringCopyZ(cx,(jschar *)p2)));
		HEAP_FREE(p2);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetStr(JSContext *cx, int argc, jsval *vp){
	char *dest;
	wchar_t *src;
	int len;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"uW/u",&dest,&src,&len)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		if(argc<3){
			len=WideCharToMultiByte(CP_ACP,0,src,-1,NULL,0,NULL,NULL);
		}
		WideCharToMultiByte(CP_ACP,0,src,-1,dest,len,NULL,NULL);
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__ToPStr(JSContext *cx, int argc, jsval *vp){
	char *dest;
	wchar_t *src;
	int len;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"W",&src)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		len=WideCharToMultiByte(CP_ACP,0,src,-1,NULL,0,NULL,NULL);
		dest=(char *)HEAP_ALLOC(len);
		WideCharToMultiByte(CP_ACP,0,src,-1,dest,len,NULL,NULL);
		JS_NewNumberValue(cx, (double)(DWORD)dest, vp);
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__StrLen(JSContext *cx, int argc, jsval *vp){
	wchar_t *src;
	int len;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"W",&src)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		len=WideCharToMultiByte(CP_ACP,0,src,-1,NULL,0,NULL,NULL);
		JS_NewNumberValue(cx, (double)len, vp);
	}SEH_END;
	return JS_TRUE;
}



JSBool __NG__GetWStr(JSContext *cx, int argc, jsval *vp){
	jschar *p;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		JS_SET_RVAL(cx,vp,STRING_TO_JSVAL(JS_NewUCStringCopyZ(cx,p)));
	}SEH_END;
	return JS_TRUE;
}

JSBool __NG__SetWStr(JSContext *cx, int argc, jsval *vp){
	wchar_t *dest;
	wchar_t *src;
	int len;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"uW/u",&dest,&src,&len)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		if(argc<3){
			len=wcslen(src)+1;
		}
		memmove(dest,src,len*sizeof(jschar));
		JS_SET_RVAL(cx,vp,JSVAL_VOID);
	}SEH_END;
	return JS_TRUE;
}


JSBool __NG__ToPWStr(JSContext *cx, int argc, jsval *vp){
	char *dest;
	wchar_t *src;
	int len;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"W",&src)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		len=wcslen(src);
		dest=(char *)HEAP_ALLOC((len+1)*sizeof(wchar_t));
		memmove(dest,src,len*sizeof(wchar_t));
		JS_NewNumberValue(cx, (double)(DWORD)dest, vp);
	}SEH_END;
	return JS_TRUE;
}








JSBool __NG__CallNativeCode(JSContext *cx, int argc, jsval *vp){
	unsigned int (*func)();
	DWORD res;
	SEH_BEGIN{
		if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&func)){
			JS_ReportError(cx,"invalid arguments");
			return JS_FALSE;
		}
		JS_EndRequest(cx);
		res=(*func)();
		JS_BeginRequest(cx);
	}SEH_END;
	
    return JS_NewNumberValue(cx, (double)res, vp);
}



JSBool __NG__CallFunctionMain(void *func, int num_argtypes,  char *argtypes, char rettype, DWORD flags, JSContext *cx, int argc, jsval *vp){
	int count,i, tmp_int;
	double tmp_double;
//	float tmp_float;
//	void *tmp_ptr;
	DWORD *my_esp;
	PEXCEPTION_POINTERS e=NULL;
	DWORD before_esp, after_esp=0,  stack_padding, res, err=0,lasterr=0;
	char *errmsg;
	jsval *argv;
	const wchar_t empty_wstr[1]={L'\0'};

	jsval errval;

	DWORD bkEAX,bkECX,bkEDX;

	//protect stack from compiler-generated code
	count=(flags|0x01)?max(num_argtypes,argc):num_argtypes;
	stack_padding=count*8;
	_asm{
		mov before_esp,esp
		sub esp,stack_padding
	}

	my_esp=(DWORD *)before_esp;
	i=count-1;
	//omitted params
	for(;i>=argc;i--){
		--my_esp;
		if(argtypes[i]<'Z'){
			*((wchar_t **)my_esp)=(wchar_t *)empty_wstr;
		}else if(argtypes[i]=='d'){
			--my_esp;
			*((double *)my_esp)=0.0;
		}else{
			*my_esp=0;
		}
	}
	argv=JS_ARGV(cx,vp);
	//given optional params for cdecl(if exists,no params omitted)
	for(;i>num_argtypes;i--){
		--my_esp;
		JS_ValueToECMAUint32(cx,*(argv+i),(DWORD *)my_esp);
	}
	//other params
	for(;i>=0;i--){
		--my_esp;
		switch(argtypes[i]){
			case('d'):{
				--my_esp;
				JS_ValueToNumber(cx,*(argv+i),(double *)my_esp);
				break;
			}case('f'):{
				JS_ValueToNumber(cx,*(argv+i),&tmp_double);
				*((float*)my_esp)=(float)tmp_double;
				break;
			}case('c'):{
			}case('s'):{
			}case('i'):{
				JS_ValueToECMAInt32(cx,*(argv+i),(int32 *)my_esp);
				break;
			}case('b'):{
			}case('w'):{
			}case('u'):default:{
				JS_ValueToECMAUint32(cx,*(argv+i),(DWORD *)my_esp);
				break;
			}
		}
/*
		if(argtypes[i]<'Z'){
			if(JSVAL_IS_NULL(argv+i)){
				*my_esp=0;
			}else{
				tmp_ptr=(void *)JS_ValueToString(cx,*(argv+i));
				*my_esp=(DWORD)JS_GetStringChars((JSString *)tmp_ptr);
				if(argtypes[i]=='W'){
					tmp_int=JS_GetStringLength((JSString *)tmp_ptr)*sizeof(wchar_t);
					tmp_ptr=HEAP_ALLOC(tmp_int+sizeof(wchar_t));
					memmove(tmp_ptr,(void *)(*my_esp),tmp_int);
					*my_esp=(DWORD)tmp_ptr;
				}else if(argtypes[i]!='U'){
					__NG__WideCharToStr((char **)(my_esp),NULL,(wchar_t *)(*my_esp));
					if(argtypes[i]=='A'){
						clearAsciiStr=1;
					}
				}
			}
		}else{
		}
*/
	}
	
	JS_EndRequest(cx);
	if(flags&0x04){
		SetLastError(ERROR_SUCCESS);
	}
	__try{
		_asm{
			mov bkEAX,eax;
			mov bkECX,ecx;
			mov bkEDX,edx;
			mov esp,my_esp;
			call [func];
			mov res,eax;
			mov eax,bkEAX;
			mov ecx,bkECX;
			mov edx,bkEDX;
			mov after_esp,esp;
			mov esp,before_esp;
		}
	}__except( e = GetExceptionInformation(), EXCEPTION_EXECUTE_HANDLER ) {
		JS_BeginRequest(cx);
		ReportStructuredException(cx,e);
		return JS_FALSE;
	}

	if(flags&0x02){
		lasterr=GetLastError();
	}
	JS_BeginRequest(cx);
	if(!(flags&0x01) && (before_esp!=after_esp)){
		JS_ReportError(cx,"incorrect arguments count(%d bytes)",before_esp-after_esp);
		return JS_FALSE;
	}

/*
	if(!(flags&0x01) && before_esp!=after_esp){
		JS_ReportError(cx,"incorrect arguments count(%d bytes)",before_esp-after_esp);
		return JS_FALSE;
	}else if(e){
		return JS_FALSE;
	}else if(rettype<'Z'){
		if(rettype=='\0'){
			JS_SET_RVAL(cx,vp,JSVAL_VOID);
		}else if(res==0){
			JS_SET_RVAL(cx,vp,JSVAL_NULL);
		}else if(rettype>='U'){
			JS_SET_RVAL(cx,vp,STRING_TO_JSVAL(JS_NewUCStringCopyZ(cx,(jschar *)res)));
			if(rettype=='U'){
				HEAP_FREE((void *)res);
			}
		}else{
			__NG__StrToWideChar((wchar_t **)(&tmp_ptr),NULL,(char *)res);
			if(rettype=='A'){
				HEAP_FREE((void *)res);
			}
			JS_SET_RVAL(cx,vp,STRING_TO_JSVAL(JS_NewUCStringCopyZ(cx,(jschar *)tmp_ptr)));
			HEAP_FREE((void *)tmp_ptr);
		}
		return JS_TRUE;
	}else{
	}
*/
	switch(rettype){
		case('d'):{
			_asm{
				fstp tmp_double
			}
			JS_NewNumberValue(cx, tmp_double, vp);
			break;
		}case('f'):{
//			tmp_float=*((float *)(&res));
			JS_NewNumberValue(cx,(jsdouble)(*((float *)(&res))),vp);
//			JS_SET_RVAL(cx,vp,DOUBLE_TO_JSVAL((jsdouble *)(&tmp_float)));
			break;
		}case('c'):{
			JS_SET_RVAL(cx,vp,INT_TO_JSVAL((int)(*((char *)(&res)))));
			break;
		}case('s'):{
			JS_SET_RVAL(cx,vp,INT_TO_JSVAL((int)((res<<16)>>16)));
			break;
		}case('i'):{
			memmove(&tmp_int,&res,4);
			if(INT_FITS_IN_JSVAL(res)){
				JS_SET_RVAL(cx,vp,INT_TO_JSVAL(tmp_int));
			}else{
				JS_NewNumberValue(cx, (double)tmp_int, vp);
			}
			break;
		}case('b'):{
			JS_SET_RVAL(cx,vp,INT_TO_JSVAL(*((unsigned char *)(&res))));
			break;
		}case('w'):{
			JS_SET_RVAL(cx,vp,INT_TO_JSVAL(*((unsigned short *)(&res))));
			break;
		}case('u'):default:{
			JS_NewNumberValue(cx, (double)res, vp);
			break;
		}
	}
	if(lasterr){
		FormatMessageA(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_IGNORE_INSERTS,0,lasterr,MAKELANGID(LANG_ENGLISH,SUBLANG_DEFAULT),(char *)(&errmsg),512,0);
		JS_ReportError(cx,"LastError=0x%X: %s",lasterr,errmsg);
		JS_GetPendingException(cx,&errval);
		JS_DefineProperty(cx,JSVAL_TO_OBJECT(errval),"code",INT_TO_JSVAL(lasterr),NULL,NULL,0);
		JS_DefineProperty(cx,JSVAL_TO_OBJECT(errval),"result",*vp,NULL,NULL,0);
		GlobalFree(errmsg);
		return JS_FALSE;
	}else{
		return JS_TRUE;
	}
	
	
}


JSBool __NG__ImportFunction(JSContext *cx, uintN argc, jsval *vp){
	char *f;
	const unsigned char code_template[51]={
		0x8b,0x44,0x24,0x0c,	//mov eax, dword [esp+0C](vp)
		0x8b,0x4c,0x24,0x08,	//mov ecx, dword [esp+08](argc)
		0x8b,0x54,0x24,0x04,	//mov edx, dword [esp+04](cx)
		0x50,				//push eax
		0x51,				//push ecx
		0x52,				//push edx
		0x68,0,0,0,0,		//push(flags)			+16
		0x68,0,0,0,0,		//push(rettype)			+21
		0x68,0,0,0,0,		//push(argtypes)		+26
		0x68,0,0,0,0,		//push(num_argtypes)	+31
		0x68,0,0,0,0,		//push(func)			+36
		0xb8,0,0,0,0,		//mov eax,mainfunc,		+41
		0xff,0xd0,			//call
		0x83,0xc4,0x20,		//add esp,0x20
		0xc3
	};
	char *argtypes;
	int num_argtypes;
	char *rettype;
	void *func;
//	DWORD oldp;
	DWORD flags;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx, vp),"ussu",&func,&argtypes,&rettype,&flags)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	num_argtypes=strlen(argtypes);
	f=(char *)HEAP_ALLOC(51+num_argtypes+1);
	memmove((void *)f,code_template,51);
	memmove((void *)(f+51),argtypes,num_argtypes+1);
	*((DWORD *)(f+36))=(DWORD)func;
	*((DWORD *)(f+31))=(DWORD)num_argtypes;
	*((DWORD *)(f+26))=(DWORD)(f+51);
	*((DWORD *)(f+21))=(DWORD)rettype[0];
	*((DWORD *)(f+16))=(DWORD)flags;
	*((DWORD *)(f+41))=(DWORD)(&__NG__CallFunctionMain);

	JS_SET_RVAL(cx,vp,OBJECT_TO_JSVAL(JS_GetFunctionObject(JS_NewFunction(cx,(JSNative)f,num_argtypes,JSFUN_FAST_NATIVE,NULL,NULL))));
	return JS_TRUE;
}






DWORD __NG__ExportedFunctionMain(JSContext *cx, JSObject *obj,JSObject *fun,int argc,char *argtypes,char rettype,DWORD flags,DWORD *my_esp){
	jsval *argv;
	jsval rval;
	JSContext *cx2;
	DWORD result=0;
	double tmp_double;
//	float tmp_float;
	int tmp_int;
	int i;
	if((flags & 0x00010000)!=0){
		cx2=__NG__CreateContextMain(JS_GetRuntime(cx));
//		JS_SetContextThread(cx2);
//		JS_SetContextPrivate(cx2,NULL);
		JS_BeginRequest(cx2);
		if((flags & 0x00020000)!=0){
			__NG__CreateGlobal(cx2,true);
		}else{
			JS_SetGlobalObject(cx2,JS_GetGlobalObject(cx));
		}
		cx=cx2;
	}else{
		JS_BeginRequest(cx);
	}
	argv=(jsval *)HEAP_ALLOC(sizeof(jsval)*argc);
	for(i=0;i<argc;i++){
		my_esp++;
		switch(argtypes[i]){
			case('d'):{
//				argv[i]=DOUBLE_TO_JSVAL(*((double *)my_esp));
				JS_NewNumberValue(cx,(jsdouble)(*((double*)(my_esp))),argv+i);
				my_esp++;
				break;
			}case('f'):{
//				*((DWORD *)(&tmp_float))=*my_esp;
				JS_NewNumberValue(cx,(jsdouble)(*((float*)(my_esp))),argv+i);
//				argv[i]=DOUBLE_TO_JSVAL((double)tmp_float);
				break;
			}case('c'):{
				argv[i]=INT_TO_JSVAL(*((char *)my_esp));
				break;
			}case('s'):{
				argv[i]=INT_TO_JSVAL(*((short *)my_esp));
				break;
			}case('i'):{
				tmp_int=(int)(*my_esp);
				if(INT_FITS_IN_JSVAL(tmp_int)){
					argv[i]=INT_TO_JSVAL(tmp_int);
				}else{
					JS_NewNumberValue(cx, (double)tmp_int, argv+i);
				}
				break;
			}case('b'):{
				argv[i]=INT_TO_JSVAL(*((unsigned char *)my_esp));
				break;
			}case('w'):{
				argv[i]=INT_TO_JSVAL(*((unsigned char *)my_esp));
				break;
			}case('u'):default:{
				JS_NewNumberValue(cx, (double)(*my_esp), argv+i);
				break;
			}
		}
	}

	if(JS_CallFunctionValue(cx,obj,OBJECT_TO_JSVAL(fun),argc,argv,&rval)==JS_TRUE){
		switch(rettype){
			case('d'):{
				JS_ValueToNumber(cx,rval,&tmp_double);
				_asm{
					fld tmp_double
				}
				break;
			}case('f'):{
				if(JS_ValueToNumber(cx,rval,&tmp_double)){
					*((float*)(&result))=(float)tmp_double;
				}
				break;
			}case('c'):case('s'):case('i'):{
				JS_ValueToECMAInt32(cx,rval,(int32 *)(&result));
				break;
			}case('b'):case('w'):case('u'):default:{
				JS_ValueToECMAUint32(cx,rval,(uint32 *)(&result));
				break;
			}
		}
	}
	
	JS_EndRequest(cx);
	if((flags & 0x00010000)!=0){
		JS_DestroyContextNoGC(cx);
	}
	HEAP_FREE(argv);
	return result;
}


JSBool __NG__ExportFunction(JSContext *cx, int argc, jsval *vp){
	unsigned char *f;
	DWORD oldp;
	const unsigned char code_template[49]={
		0x54,				//push(esp)
		0x68,0,0,0,0,		//push(flags)		+2
		0x68,0,0,0,0,		//push(rettype)		+7
		0x68,0,0,0,0,		//push(argtypes)	+12
		0x68,0,0,0,0,		//push(argc)		+17
		0x68,0,0,0,0,		//push(fun)			+22
		0x68,0,0,0,0,		//push(obj)			+27
		0x68,0,0,0,0,		//push(cx)			+32
		0xb8,0,0,0,0,		//mov eax,mainfunc,	+37
		0xff,0xd0,			//call
		0x83,0xc4,0x20,		//add esp,0x20
		0xC2,0x00,0x00		//ret				
	};
	JSObject *func;
	JSObject *obj;
	int num_argtypes,argsize,i;
	char *argtypes;
	char *rettype;
	DWORD flags;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"ossu/o",&func,&argtypes,&rettype,&flags,&obj)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	if(argc<5){
		JS_ValueToObject(cx,JSVAL_VOID,&obj);
	}
	if(!JS_ObjectIsFunction(cx,func)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	num_argtypes=strlen(argtypes);
	argsize=num_argtypes*sizeof(DWORD);
	for(i=0;i<num_argtypes;i++){
		if(argtypes[i]=='d'){
			argsize+=sizeof(DWORD);
		}
	}
	f=(unsigned char *)HEAP_ALLOC(49+num_argtypes+1);
	VirtualProtect(f,49+num_argtypes+1,PAGE_EXECUTE_READWRITE,&oldp);
//	f=(unsigned char *)VirtualAlloc(NULL, 49+num_argtypes+1,MEM_COMMIT,PAGE_EXECUTE_READWRITE);;
	memmove((void *)f,code_template,49);
	memmove((void *)(f+49),argtypes,num_argtypes+1);

	*((DWORD *)(f+32))=(DWORD)cx;
	*((DWORD *)(f+27))=(DWORD)obj;
	*((DWORD *)(f+22))=(DWORD)func;
	*((DWORD *)(f+17))=(DWORD)num_argtypes;
	*((DWORD *)(f+12))=(DWORD)(f+49);
	*((DWORD *)(f+7 ))=(DWORD)rettype[0];
	*((DWORD *)(f+2 ))=(DWORD)flags;
	*((DWORD *)(f+37))=(DWORD)(&__NG__ExportedFunctionMain);
	
	JS_AddRoot(cx,f+27);
	JS_AddRoot(cx,f+22);

	if(flags&0x01){
		f[46]=0xC3;
	}else{
		*((unsigned short*)(f+47))=(WORD)argsize;
	}
	JS_NewNumberValue(cx, (double)((DWORD)f), vp);
    return JS_TRUE;	
}





JSBool __NG__LoadFileMain(wchar_t *wfn, wchar_t **dest, size_t *size){
	JSBool res;
	HANDLE hFile;
	DWORD filesize;
	DWORD readsize;
	char *src;
	hFile=CreateFileW(wfn, GENERIC_READ, FILE_SHARE_READ,NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
	if(hFile==INVALID_HANDLE_VALUE){
		return JS_FALSE;
	}
	filesize=GetFileSize(hFile, NULL);
	src=(char *)HEAP_ALLOC(filesize+1);
	ReadFile(hFile,src,filesize,&readsize,NULL);
	CloseHandle(hFile);
	if(filesize!=readsize){
		return JS_FALSE;
	}
	*(src+filesize)='\0';
	res=__NG__StrToWideChar(dest,size,src);
	HEAP_FREE(src);
	return res;
};
JSBool __NG__LoadFile(JSContext *cx, int argc, jsval *vp){
	wchar_t *fn;
	wchar_t *content;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"W",&fn)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	__NG__LoadFileMain(fn,&content,NULL);
	if(content){
		JS_SET_RVAL(cx,vp,STRING_TO_JSVAL(JS_NewUCStringCopyZ(cx,(jschar *)content)));
	}
	return TRUE;
}




JSBool __NG__EvalFileMain(JSContext *cx, wchar_t *wfn ,JSObject *obj, jsval *rval){
	uint32 oldopts;
	size_t wsrcsize;
	wchar_t *wsrc;
	JSBool result;
	char fn[MAX_PATH];
	WideCharToMultiByte(932,0,wfn,-1,fn,sizeof(fn),NULL,NULL);
	if(__NG__LoadFileMain(wfn,&wsrc,&wsrcsize)){
		oldopts = JS_GetOptions(cx);
		JS_SetOptions(cx, oldopts | JSOPTION_COMPILE_N_GO);
		result=JS_EvaluateUCScript(cx, obj, (jschar *)wsrc, wsrcsize-1, fn, 1, rval);
		JS_SetOptions(cx, oldopts);
		HEAP_FREE(wsrc);
		return result;
	}else{
		JS_ReportError(cx,"load file error: %s",fn);
		return JS_FALSE;
	}
}

JSBool __NG__EvalFile(JSContext *cx, int argc, jsval *vp){
//	JSBool result;
	wchar_t *fn;
	JSObject *obj;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"W/o",&fn,&obj)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	if(argc<3){
		obj=JS_GetGlobalObject(cx);
	}
	return __NG__EvalFileMain(cx,fn,obj,vp);
}

JSBool __NG__ContextEvalFile(JSContext *cx, int argc, jsval *vp){
	JSBool result;
	wchar_t *fn;
//	JSObject *obj;
	JSContext *cx2;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"uW",&cx2,&fn)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	JS_SetContextThread(cx2);
	JS_BeginRequest(cx2);
	result=__NG__EvalFileMain(cx2,fn,JS_GetGlobalObject(cx2),vp);
	JS_EndRequest(cx2);
	JS_ClearContextThread(cx2);
	return result;
}




JSBool __NG__EvalStringMain(JSContext *cx, jschar *wsrc, size_t len, char *fn,unsigned int lineno ,JSObject *obj, jsval *rval){
	JSBool result;
	uint32 oldopts;
	oldopts = JS_GetOptions(cx);
	JS_SetOptions(cx, oldopts | JSOPTION_COMPILE_N_GO);
	result=JS_EvaluateUCScript(cx, obj,wsrc,len, fn, lineno, rval);
	JS_SetOptions(cx, oldopts);
	return result;
}
JSBool __NG__EvalString(JSContext *cx, int argc, jsval *vp){
	JSString *source;
	char *filename = "";
	jsuint lineno = 1;
//	uint32 oldopts;
//	JSBool ok;

	if (!JS_ConvertArguments(cx, argc, JS_ARGV(cx,vp), "S/su",&source, &filename, &lineno)) {
	    return JS_FALSE;
	}
	return __NG__EvalStringMain(cx,JS_GetStringChars(source),JS_GetStringLength(source), filename, lineno,JS_GetGlobalObject(cx),vp);
}
JSBool __NG__ContextEvalString(JSContext *cx, int argc, jsval *vp){
	JSString *source;
	char *filename = "";
	jsuint lineno = 1;
	JSContext *cx2;
//	uint32 oldopts;
	JSBool result;
	if (!JS_ConvertArguments(cx, argc, JS_ARGV(cx,vp), "uS/su",&cx2,&source, &filename, &lineno)) {
	    return JS_FALSE;
	}
	JS_SetContextThread(cx2);
	JS_BeginRequest(cx2);
	result= __NG__EvalStringMain(cx2,JS_GetStringChars(source),JS_GetStringLength(source), filename, lineno,JS_GetGlobalObject(cx2),vp);
	JS_EndRequest(cx2);
	JS_ClearContextThread(cx2);
	return result;
}



DWORD WINAPI __NG__ThreadProc(JSContext *cx){
	jsval rval;
	DWORD res;
	
	JS_SetContextThread(cx);
	JSString *s=(JSString *)JS_GetContextPrivate(cx);
	JS_SetContextPrivate(cx,0);
	JS_BeginRequest(cx);
	JS_EvaluateUCScript(cx, JS_GetGlobalObject((JSContext *)cx), JS_GetStringChars(s),JS_GetStringLength(s), "", 1, &rval);
	JS_EndRequest(cx);
	JS_ClearContextThread(cx);
	JS_DestroyContext(cx);
	JS_ValueToECMAUint32(cx,rval,&res);
	HEAP_FREE(s);
	return res;
}

JSBool __NG__ContextExecThread(JSContext *cx, int argc, jsval *vp){
	JSContext *cx2;
	JSString *source;
	if (!JS_ConvertArguments(cx, argc, JS_ARGV(cx,vp), "uS",&cx2,&source)) {
	    return JS_FALSE;
	}
	JS_SetContextThread(cx2);
	JS_SetContextPrivate(cx2,source);
	JS_ClearContextThread(cx2);
	return JS_NewNumberValue(cx, (double)(DWORD)CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)__NG__ThreadProc,cx2,0,NULL), vp);
}








static JSClass global_class = {"global", JSCLASS_GLOBAL_FLAGS,
	JS_PropertyStub, JS_PropertyStub, JS_PropertyStub, JS_PropertyStub,
	JS_EnumerateStub, JS_ResolveStub, JS_ConvertStub, JS_FinalizeStub,
	JSCLASS_NO_OPTIONAL_MEMBERS
};



/*

JSBool __NG__OperationCallback(JSContext *cx,JSScript *script){
	unsigned int c=(unsigned int)JS_GetContextPrivate(cx);
	if(c<GetTickCount()){
		JS_ReportError(cx,"timelimit");
		return JS_FALSE;
	}
	printf("aaa");
	return JS_TRUE;
}

JSBool __NG__SetTimeLimit(JSContext *cx, int argc, jsval *vp){
	DWORD v;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&v)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	if(v){
		JS_SetContextPrivate(cx,(void *)(GetTickCount()+v));
		((void (*)(JSContext *, JSBool (*)(JSContext *,JSScript *)))JS_SetOperationCallback)(cx,__NG__OperationCallback);
		((void (*)(JSContext *))GetProcAddress(GetModuleHandle(L"js3250.dll"),"JS_TriggerOperationCallback"))(cx);
	}else{
		((void (*)(JSContext *, JSBool (*)(JSContext *,JSScript *)))JS_SetOperationCallback)(cx,NULL);
	}
	return JS_TRUE;
}

JSBool gccb(JSContext *cx, JSGCStatus status){
	char str[1024];
	if(status==JSGC_BEGIN){
		sprintf_s((char *)str,(size_t)1024, "GC_BEG %x\n",GetCurrentThreadId());
		WriteFile(GetStdHandle(-12),str,strlen(str)*sizeof(char),NULL,NULL);
	}else if(status==JSGC_END){
		sprintf_s((char *)str,(size_t)1024, "GC_END %x\n",GetCurrentThreadId());
		WriteFile(GetStdHandle(-12),str,strlen(str)*sizeof(char),NULL,NULL);
	}
	return JS_TRUE;
}
*/



JSContext *__NG__CreateContextMain(JSRuntime *rt){
	JSContext *cx;
/*
char str[1024];
	sprintf_s((char *)str,(size_t)1024, "TH_CRE %x\n",GetCurrentThreadId());
	WriteFile(GetStdHandle(-12),str,strlen(str)*sizeof(char),NULL,NULL);
	JS_SetGCCallbackRT(rt,(JSGCCallback)gccb);
*/
	if ((cx = JS_NewContext(rt, 8192)) == NULL){
		return NULL;
	}
	JS_SetOptions(cx, JSOPTION_VAROBJFIX | JSOPTION_XML /*| JSOPTION_UNROOTED_GLOBAL*/);
	JS_SetVersion(cx, JSVERSION_LATEST);
//	((void (*)(JSContext *, JSBool (*)(JSContext *,JSScript *)))JS_SetOperationCallback)(cx,__NG__OperationCallback);
	return(cx);
}

JSBool __NG__CreateContext(JSContext *cx, int argc, jsval *vp){
	JSContext *cx2;
	JSObject *global;
	if ((cx2 = __NG__CreateContextMain(JS_GetRuntime(cx))) == NULL){
		return JS_FALSE;
	}
	if((global = __NG__CreateGlobal(cx2,true))==NULL){
		return JS_FALSE;
	}
	JS_SetContextPrivate(cx,NULL);
	return JS_NewNumberValue(cx, (double)(DWORD)cx2, vp);
}

JSBool __NG__CreateSafeContext(JSContext *cx, int argc, jsval *vp){
	JSContext *cx2;
	JSObject *global;
	if ((cx2 = __NG__CreateContextMain(JS_GetRuntime(cx))) == NULL){
		return JS_FALSE;
	}
	if((global = __NG__CreateGlobal(cx2,false))==NULL){
		return JS_FALSE;
	}
	return JS_NewNumberValue(cx, (double)(DWORD)cx2, vp);
}
JSBool __NG__FreeContext(JSContext *cx, int argc, jsval *vp){
	JSContext *cx2;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&cx2)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	JS_DestroyContext(cx2);
	return JS_TRUE;	
}


JSBool __NG__ContextSetErrorReporter(JSContext *cx, int argc, jsval *vp){
	JSContext *cx2;
	JSErrorReporter func;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"uu",&cx2,&func)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	JS_SetErrorReporter(cx,func);
	return JS_TRUE;	
}









JSBool __NG__HostPath(JSContext *cx, int argc, jsval *vp){
	wchar_t filepath[MAX_PATH];
	GetModuleFileNameW(NULL,filepath,MAX_PATH);
	JS_SET_RVAL(cx,vp,STRING_TO_JSVAL(JS_NewUCStringCopyZ(cx,(jschar *)filepath)));
	return JS_TRUE;
}
JSBool __NG__ThisContext(JSContext *cx, int argc, jsval *vp){
    return JS_NewNumberValue(cx, (double)(unsigned int)cx, vp);
}
JSBool __NG__ContextGetGlobal(JSContext *cx, int argc, jsval *vp){
	JSContext *cx2;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&cx2)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx,vp,OBJECT_TO_JSVAL(JS_GetGlobalObject(cx2)));
	return JS_TRUE;
}


JSBool __NG__ToPointer(JSContext *cx, int argc, jsval *vp){
	DWORD p;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"o",&p)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	return JS_NewNumberValue(cx, (double)p, vp);
}
JSBool __NG__FromPointer(JSContext *cx, int argc, jsval *vp){
	DWORD p;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&p)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx,vp,OBJECT_TO_JSVAL((JSObject *)p));
	return JS_TRUE;
}
JSBool __NG__ToJSVal(JSContext *cx, int argc, jsval *vp){
	return JS_NewNumberValue(cx, (double)((DWORD)(JS_ARGV(cx,vp)[0])), vp);
}
JSBool __NG__FromJSVal(JSContext *cx, int argc, jsval *vp){
	DWORD v;
	if(!JS_ConvertArguments(cx,argc,JS_ARGV(cx,vp),"u",&v)){
		JS_ReportError(cx,"invalid arguments");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx,vp,v);
	return JS_TRUE;
}

JSBool __NG__GC(JSContext *cx, int argc, jsval *vp){
	JS_GC(cx);
	return JS_TRUE;
}
JSBool __NG__MaybeGC(JSContext *cx, int argc, jsval *vp){
	JS_MaybeGC(cx);
	return JS_TRUE;
}




static JSFunctionSpec ng_global_functions[] = {
	JS_FN("__NG__HostPath",			__NG__HostPath,			0,0),
	JS_FN("__NG__LoadFile",			__NG__LoadFile,				1,0),
	JS_FN("__NG__EvalString",		__NG__EvalString,		3,0),
	JS_FN("__NG__EvalFile",			__NG__EvalFile,			1,0),

	JS_FN("__NG__ThisContext",		__NG__ThisContext,		0,0),
	JS_FN("__NG__CreateContext",	__NG__CreateContext,	0,0),
	JS_FN("__NG__CreateSafeContext",__NG__CreateSafeContext,0,0),
	JS_FN("__NG__FreeContext",		__NG__FreeContext,		1,0),
	JS_FN("__NG__ContextGetGlobal",	__NG__ContextGetGlobal,		1,0),
	JS_FN("__NG__ContextEvalString",__NG__ContextEvalString,4,0),
	JS_FN("__NG__ContextEvalFile",	__NG__ContextEvalFile,	2,0),
	JS_FN("__NG__ContextExecThread",__NG__ContextExecThread,2,0),
	JS_FN("__NG__ToPointer",		__NG__ToPointer,		1,0),
	JS_FN("__NG__FromPointer",		__NG__FromPointer,		1,0),
	JS_FN("__NG__ToJSVal",			__NG__ToJSVal,			1,0),
	JS_FN("__NG__FromJSVal",		__NG__FromJSVal,		1,0),
	JS_FN("__NG__GC",				__NG__GC,				0,0),
	JS_FN("__NG__MaybeGC",			__NG__MaybeGC,		0,0),

	JS_FN("__NG__ImportFunction",	__NG__ImportFunction,	4,0),
	JS_FN("__NG__CallNativeCode",	__NG__CallNativeCode,	1,0),
	JS_FN("__NG__ExportFunction",	__NG__ExportFunction,	5,0),
	JS_FN("__NG__GetModuleHandle",	__NG__GetModuleHandle,	1,0),
	JS_FN("__NG__LoadLibrary",		__NG__LoadLibrary,		1,0),
	JS_FN("__NG__GetProcAddress",	__NG__GetProcAddress,	2,0),
	JS_FN("__NG__FreeLibrary",		__NG__FreeLibrary,		1,0),

	JS_FN("__NG__Alloc",			__NG__Alloc,			1,0),
	JS_FN("__NG__Free",				__NG__Free,				1,0),
	JS_FN("__NG__MoveMemory",		__NG__MoveMemory,		3,0),
	JS_FN("__NG__GetUInt64",		__NG__GetUInt64,		1,0),
	JS_FN("__NG__SetUInt64",		__NG__SetUInt64,		2,0),
	JS_FN("__NG__GetInt64",			__NG__GetInt64,			1,0),
	JS_FN("__NG__SetInt64",			__NG__SetInt64,			2,0),
	JS_FN("__NG__GetInt",			__NG__GetInt,			1,0),
	JS_FN("__NG__SetInt",			__NG__SetInt,			2,0),
	JS_FN("__NG__GetUInt",			__NG__GetUInt,			1,0),
	JS_FN("__NG__SetUInt",			__NG__SetUInt,			2,0),
	JS_FN("__NG__GetShort",			__NG__GetShort,			1,0),
	JS_FN("__NG__SetShort",			__NG__SetShort,			2,0),
	JS_FN("__NG__GetWord",			__NG__GetWord,			1,0),
	JS_FN("__NG__SetWord",			__NG__SetWord,			2,0),
	JS_FN("__NG__GetChar",			__NG__GetChar,			1,0),
	JS_FN("__NG__SetChar",			__NG__SetChar,			2,0),
	JS_FN("__NG__GetByte",			__NG__GetByte,			1,0),
	JS_FN("__NG__SetByte",			__NG__SetByte,			2,0),
	JS_FN("__NG__GetFloat",			__NG__GetFloat,			1,0),
	JS_FN("__NG__SetFloat",			__NG__SetFloat,			2,0),
	JS_FN("__NG__GetDouble",		__NG__GetDouble,		1,0),
	JS_FN("__NG__SetDouble",		__NG__SetDouble,		2,0),
	JS_FN("__NG__GetStr",			__NG__GetStr,			1,0),
	JS_FN("__NG__SetStr",			__NG__SetStr,			3,0),
	JS_FN("__NG__ToPStr",			__NG__ToPStr,			1,0),
	JS_FN("__NG__StrLen",			__NG__StrLen,			1,0),
	JS_FN("__NG__GetWStr",			__NG__GetWStr,			1,0),
	JS_FN("__NG__SetWStr",			__NG__SetWStr,			3,0),
	JS_FN("__NG__ToPWStr",			__NG__ToPWStr,			1,0),
    JS_FS_END
};

/*
static JSClass ng_exit_class = {"ExitSuccessfully", 0,
	JS_PropertyStub, JS_PropertyStub, JS_PropertyStub, JS_PropertyStub,
	JS_EnumerateStub, JS_ResolveStub, JS_ConvertStub, JS_FinalizeStub,
	JSCLASS_NO_OPTIONAL_MEMBERS
};
*/


JSObject *__NG__CreateGlobal(JSContext *cx, bool define_funcs){
   JSObject  *global=JS_NewObject(cx, &global_class, NULL, NULL);
	if(!JS_InitStandardClasses(cx, global)){
		return NULL;
	}
	if(define_funcs){
		if(!JS_DefineFunctions(cx, global, ng_global_functions)){
			return NULL;
		}
	    void *mark;
		jsval *args;
		jsval exc;
		if(args = JS_PushArguments(cx, &mark, "s", "ExitSuccessfully")){
			if(JS_CallFunctionName(cx, JS_GetGlobalObject(cx),"Error", 1, args, &exc)){
				JS_SetProperty(cx,global,"__NG__ExitSuccessfully",&exc);
				JS_PopArguments(cx, mark);
			}
		}
	}
	return(global);
}


